/* Kernel module to match various things tied to sockets associated with
   locally generated outgoing packets. */

/* (C) 2000 Marc Boucher <marc@mbsi.ca>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include <linux/module.h>
#include <linux/skbuff.h>
#include <linux/file.h>
#include <linux/rcupdate.h>
#include <net/sock.h>

#include <linux/netfilter_ipv4/ipt_owner.h>
#include <linux/netfilter_ipv4/ip_tables.h>

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Marc Boucher <marc@mbsi.ca>");
MODULE_DESCRIPTION("iptables owner match");

static int
match3(const struct sk_buff *skb,
      const struct net_device *in,
      const struct net_device *out,
      const struct xt_match *match,
      const void *matchinfo,
      int offset,
      unsigned int protoff,
      int *hotdrop)
{
	printk("Me llaman!!\n");
	return 1;
}

static int
checkentry3(const char *tablename,
           const void *ip,
	   const struct xt_match *match,
           void *matchinfo,
           unsigned int matchsize,
           unsigned int hook_mask)
{
	printk("ME llaman para aceptar la regla!!\n");
	return 1;
}

static struct ipt_match owner_match = {
	.name		= "ghost",
	.match		= match3,
	.matchsize	= sizeof(struct ipt_owner_info),
	.hooks		= (1 << NF_IP_LOCAL_OUT) | (1 << NF_IP_POST_ROUTING),
	.checkentry	= checkentry3,
	.me		= THIS_MODULE,
};

static int __init ipt_owner_init(void)
{
	printk("Se levanta el sistema y hemos pillado la movida\n");
	return ipt_register_match(&owner_match);
}

static void __exit ipt_owner_fini(void)
{
	ipt_unregister_match(&owner_match);
}

module_init(ipt_owner_init);
module_exit(ipt_owner_fini);
