#include <linux/config.h>
#include <linux/module.h>
#include <linux/version.h>
#include <linux/netdevice.h>
#include <net/protocol.h>

#define MAX 5

struct device *d;

struct packet_type mi_proto;

static int pktgen_device_event(struct notifier_block *unused,unsigned long event, void *ptr);

static struct notifier_block pktgen_notifier_block = {
	.notifier_call = pktgen_device_event,
};

static int pktgen_device_event(struct notifier_block *unused,unsigned long event, void *ptr)
{
	struct net_device *dev = (struct net_device *)(ptr);
		//Nos avisa de los cambios en todos los dispositivos :P

	switch (event) {

		case NETDEV_CHANGE:
			printk("Ha cambiado ... %s\n",dev->name);
		break;
		case NETDEV_CHANGEADDR:
			printk("Ha cambiado de dirección ... %s\n",dev->name);
		break;
		case NETDEV_GOING_DOWN:
			printk("Va a bajar %s\n",dev->name);
			if (strcmp(dev->name,"eth1")==0 && mi_proto.dev!=NULL)
			{	
				//dev_remove_pack(&mi_proto);
				//mi_proto.dev=NULL;
			}
		break;
		case NETDEV_DOWN:
			printk("Se ha cerrado %s\n",dev->name);
		break;
		case NETDEV_UP:
			printk("Se ha levantado %s\n",dev->name);
			if (strcmp(dev->name,"eth1")==0)
			{
				mi_proto.dev = dev;
				printk("up!!\n");
				dev_add_pack(&mi_proto);
			}
			
		break;
		case NETDEV_UNREGISTER:
			printk("Se ha desregistrado %s \n",dev->name);
		break;
		default:	
			printk("Otro evento ha llegado :S \n");
	};

	return NOTIFY_DONE;
}
/*Función que se encarga de registrar*/
int func(struct sk_buff *skb, struct device *dv, struct packet_type *pt) {

	printk("Hemos pillado un paquete!!");
    return 0;
}

int init_module() {

		mi_proto.dev=NULL;
		mi_proto.type = htons(ETH_P_ALL); 
		mi_proto.func = func;
    		register_netdevice_notifier(&pktgen_notifier_block);
	return(0);
}

void cleanup_module() {
	
    printk("Nos descargamos");
   if (mi_proto.dev!=NULL)
	   dev_remove_pack(&mi_proto);
    unregister_netdevice_notifier(&pktgen_notifier_block);
}


